﻿using MvcXmlActionResult.CustomActionResults;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.ServiceModel.Syndication;
using System.Web;
using System.Web.Mvc;
using System.Xml;
using System.Xml.Linq;

namespace MvcXmlActionResult.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "ASP.NET MVC Custom ActionResult Demo.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Code project sample XmlActionResult Demo.";

            return View();
        }

        [HttpGet]
        public XmlActionResult GetXmlData()
        {
            System.Xml.XmlTextReader reader = new System.Xml.XmlTextReader(Server.MapPath("~/Book.xml"));
            var xml = XElement.Load(reader);
            return new XmlActionResult(xml.ToString(), "book.xml");
        }

        [HttpGet]
        public ActionResult GetRssFeeds()
        {
            XmlReader reader = XmlReader.Create("http://www.codeproject.com/webservices/articlerss.aspx",
            new XmlReaderSettings()
            {
                //MaxCharactersInDocument can be used to control the maximum amount of data 
                //read from the reader and helps prevent OutOfMemoryException
                MaxCharactersInDocument = 1024 * 64
            });

            SyndicationFeed feed = SyndicationFeed.Load(reader);         
            var rssFeed = new FeedActionResult(feed, FeedType.Rss);
            return rssFeed;
        }
    }
}
