﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Syndication;
using System.Web;
using System.Web.Mvc;
using System.Xml;

namespace MvcXmlActionResult.CustomActionResults
{
    public enum FeedType
    {
        Atom,
        Rss
    }

    public class FeedActionResult : ActionResult
    {
        private SyndicationFeedFormatter formatter;

        public FeedActionResult(SyndicationFeed feed, FeedType feedType)
        {
            switch (feedType)
            {
                case FeedType.Atom:
                    formatter = new Atom10FeedFormatter(feed);
                    break;
                case FeedType.Rss:
                    formatter = new Rss20FeedFormatter(feed);
                    break;
            }
        }

        public SyndicationFeed Feed { get; set; }

        public override void ExecuteResult(ControllerContext context)
        {
            context.HttpContext.Response.ContentType = "application/rss+xml";
            using (var writer = XmlWriter.Create(context.HttpContext.Response.Output))
            {
                formatter.WriteTo(writer);
            }
        }
    }
}